/* only needed for AVR */

#include <avr/interrupt.h>
#if !defined(DEFINES_H)
    #include "defines.h"
#endif

#include "uart_int.h"
/* ------------------------------------------ */

#if defined(__AVR__)

ISR(USART_UDRE_vect)
{
    if ((flagi & FLAG_SERIAL_TX_TO_SEND) == FLAG_SERIAL_TX_TO_SEND) {
    #if (defined(__AVR_ATmega328P__) || defined(__AVR_ATmega168P__) || defined(__AVR_ATmega88P__))
	if (buffer_tx[tx_pointer] != 0) { UDR0 = buffer_tx[tx_pointer++]; }
    #endif
    #if defined(__AVR_ATmega8__)
	if (buffer_tx[tx_pointer] != 0) { UDR = buffer_tx[tx_pointer++]; }
    #endif
	else {
	  #if (defined(__AVR_ATmega328P__) || defined(__AVR_ATmega168P__) || defined(__AVR_ATmega88P__))
	    UCSR0B &= ~_BV(UDRIE0);	/* disARM Tx buffer empty interrupt */
	  #endif
	  #if defined(__AVR_ATmega8__)
	    UCSRB &= ~_BV(UDRIE);	/* disARM Tx buffer empty interrupt */
	  #endif
	    for (tx_pointer = 0; tx_pointer < (sizeof buffer_tx) ; tx_pointer++)
		{ buffer_tx[tx_pointer] = 0; }	/* clear buffer_tx */
	    tx_pointer = 0;
	    flagi &= ~FLAG_SERIAL_TX_TO_SEND;
	    }
	} else
#if (defined(__AVR_ATmega328P__) || defined(__AVR_ATmega168P__) || defined(__AVR_ATmega88P__))
    { UCSR0B &= ~_BV(UDRIE0); }		/* disARM Tx buffer empty interrupt */
#endif
#if defined(__AVR_ATmega8__)
    { UCSRB &= ~_BV(UDRIE); }		/* disARM Tx buffer empty interrupt */
#endif
						/* spurious interrupt */
}

#endif /* defined(__AVR__) */

/* ------------------------------------------ */
